"use strict";
var chai = require("chai");
var errorbuilder_1 = require("./errorbuilder");
var Joi = require("joi");
describe('ErrorBuilder', function () {
    var _classUnderTest;
    var expect = chai.expect;
    var _schema;
    var joiOptions = {
        context: {},
        allowUnknown: true,
        abortEarly: false
    };
    describe('buildErrors', function () {
        beforeEach(function () {
            _schema = { first: Joi.string().required(), second: Joi.string().required() };
            _classUnderTest = new errorbuilder_1.ErrorBuilder();
        });
        it('should translate joi errors', function (done) {
            var error = Joi.validate({}, _schema, joiOptions).error;
            var actual = _classUnderTest.buildErrors(error);
            expect(actual).to.contain({ field: 'first', messages: ['"first" is required'] });
            expect(actual).to.contain({ field: 'second', messages: ['"second" is required'] });
            done();
        });
    });
});
//# sourceMappingURL=errorbuilder.spec.js.map