"use strict";
var Joi = require("joi");
var _ = require("lodash");
var errorbuilder_1 = require("./errorbuilder");
var ValidatorMiddleware = (function () {
    function ValidatorMiddleware() {
    }
    ValidatorMiddleware.prototype.bindModel = function (req, res, next) {
        var model = _.extend({}, req.body, req.params, req.query);
        req._model = model;
        next();
    };
    ValidatorMiddleware.prototype.validateModel = function (req, res, next) {
        var model = req._model;
        var schema = req._schema;
        var joiOptions = {
            context: req,
            allowUnknown: true,
            abortEarly: false
        };
        var _a = Joi.validate(model, schema, joiOptions), error = _a.error, value = _a.value;
        if (!error || error.details.length === 0) {
            req._model = value;
            next();
        }
        else {
            var errors = errorbuilder_1.errorBuilder.buildErrors(error);
            res.status(400).send({ message: 'Bad Request', errors: errors });
        }
    };
    return ValidatorMiddleware;
}());
exports.ValidatorMiddleware = ValidatorMiddleware;
exports.validatorMiddleware = new ValidatorMiddleware();
//# sourceMappingURL=validator.middleware.js.map